import java.awt.*;
import java.applet.*;
import java.net.URL;
import graph.*;

import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.text.*;
import java.lang.*;


public class example1 extends Applet implements ActionListener {
    
      Graph2D graph;
      DataSet data1;
      DataSet data2;
      Axis    xaxis;
      Axis    yaxis_left;
      Axis    yaxis_right;
      double data[];
      int np;
      URL markerURL;
      int i;
      int j;
      int k;
      JButton bt, track, box;
      double s = 10;
      double b =8.0/3.0;
      double r= 28;
      double dt=0.005;
      double x0 = 0;
      double y0 = 1;
      double z0 = 0;
      double NormStep = 1, NormWait=10;
      JPanel stuff, GSel, slidePanel;
      JTextField TFs, TFb, TFr, TFx0, TFy0, TFz0, TFdt, TFtmax, TFNormStep, TFNormWait;
      JLabel Lambda1, Lambda2, Lambda3, Dim, Cord, BDim;
      double tmax = 50;
      boolean run = false, DF=false, ghost=false;
      double X, Y, Z;
      int GraphSel=0;
      JRadioButton zx, yx, zy, L1t, L1tA, L2t, L2tA, L3t, L3tA, DtA, RK, Eul;
      int tcount = 0, rate = 830;
      Timer delay;
      JSlider slide;
      NumberFormat form;
      MyChangeListener slideChange;
      boolean RungeEuler = true; //true indicates use Runge-Kutta, false indicates use Euler
      double x[], y[], z[];
      boolean BC = false; //true indicates the box-count feature was just used and the axes labels need to be reset
      
      double datab[];
      DataSet data3;
      
      

      public void init() {

/*
**      Get the passed parameters
*/

        String mfile    = getParameter("MARKERS");
/*
**      Create the Graph instance and modify the default behaviour
*/
        graph = new Graph2D();
        graph.drawzero = false;
        graph.drawgrid = false;
        graph.borderTop = 50;
/*
**      Load a file containing Marker definitions
*/
        try {
           markerURL = new URL(getDocumentBase(),mfile);

        } catch(Exception e) {
           System.out.println("Failed to create Marker URL!");
        }
        
        try {
            graph.setMarkers(new Markers(markerURL));
        } catch(Exception e){
            System.out.println("Failed to setMarker" + e.getMessage() );
        }

//initialize layout, buttons, and action listeners

        slideChange = new MyChangeListener(this);
        
        form = new DecimalFormat("0.0000"); //form is a format for numbers that will be displayed with 4 decimals
        
        setLayout( new BorderLayout() );
        add("Center", graph);
        
        stuff=new JPanel(new GridLayout(15, 2)); //GridLayout(rows, columns, hgap, vgap)
        
        ButtonGroup ISelGroup = new ButtonGroup(); //ButtonGroup allows only one radio button to be selected at a time
        //Runge-Kutta and Euler are integration technique options
        RK = new JRadioButton("Runge-Kutta");
        RK.addActionListener(this);
        RK.setSelected(true);
        ISelGroup.add(RK);
        stuff.add(RK);
        Eul = new JRadioButton("Euler");
        Eul.addActionListener(this);
        ISelGroup.add(Eul);
        stuff.add(Eul);        
        
        //equation parameters that can be changed by user, sigma, b, and r
        TFs=new JTextField(String.valueOf(s));
        stuff.add(new JLabel("\u03c3 =", 2)); //unicode of sigma
        stuff.add(TFs);
        
        TFb=new JTextField(String.valueOf(b));
        stuff.add(new JLabel("b ="));
        stuff.add(TFb);
        
        TFr=new JTextField(String.valueOf(r));
        stuff.add(new JLabel("r ="));
        stuff.add(TFr);
        
        //initial conditions that can be changed by user
        TFx0=new JTextField(String.valueOf(x0));
        stuff.add(new JLabel("x0 ="));
        stuff.add(TFx0);
            
        TFy0=new JTextField(String.valueOf(y0));
        stuff.add(new JLabel("y0 ="));
        stuff.add(TFy0);    
        
        TFz0=new JTextField(String.valueOf(z0));
        stuff.add(new JLabel("z0 ="));
        stuff.add(TFz0);
        
        //time step that can be changed by user
        TFdt=new JTextField(String.valueOf(dt));
        stuff.add(new JLabel("dt ="));
        stuff.add(TFdt);    
        
        //max time unit that can be changed by user
        TFtmax=new JTextField(String.valueOf(tmax));
        stuff.add(new JLabel("t-max ="));
        stuff.add(TFtmax);
        
        //options for Lyapunov calculations that can be changed by user
        TFNormStep=new JTextField(String.valueOf(NormStep));
        stuff.add(new JLabel("Norm. step-time ="));
        stuff.add(TFNormStep);                              
        
        TFNormWait=new JTextField(String.valueOf(NormWait));
        stuff.add(new JLabel("Norm. wait time ="));
        stuff.add(TFNormWait);  
        
        //Lyapunov exponents and dimension displayed for user
        Lambda1=new JLabel('\u03BB'+"1 =");
        stuff.add(Lambda1);
        Lambda2=new JLabel('\u03BB'+"2 =");
        stuff.add(Lambda2);
        Lambda3=new JLabel('\u03BB'+"3=");
        stuff.add(Lambda3);
        Dim=new JLabel("D=");
        stuff.add(Dim);
        
        //restart button to re-evaluate system with parameters in text field
        bt = new JButton("Restart");
        bt.addActionListener(this);
        stuff.add(bt);
        
        //track button to activate track option
        track = new JButton("Track");
        track.addActionListener(this);
        stuff.add(track);
        
        //box-count button to activate box-counting dimesnion calculation
        box = new JButton("Box-Count");
        box.addActionListener(this);
        stuff.add(box);
        
        //box-count results displayed for user
        BDim = new JLabel("  Db=");
        stuff.add(BDim);
        
        add("East", stuff);
        
        //graph seletions
        GSel = new JPanel(new GridLayout(11,1));
        ButtonGroup GSelGroup = new ButtonGroup();
        
        GSel.add(new JLabel("Graph Select"));
        
        zx = new JRadioButton("Z-X");
        zx.addActionListener(this);
        zx.setSelected(true);
        GSelGroup.add(zx);
        GSel.add(zx);
        
        yx = new JRadioButton("Y-X");
        yx.addActionListener(this);
        GSelGroup.add(yx);
        GSel.add(yx);
        
        zy = new JRadioButton("Z-Y");
        zy.addActionListener(this);
        GSelGroup.add(zy);
        GSel.add(zy);
        
        L1t = new JRadioButton('\u03BB'+"1t-t");
        L1t.addActionListener(this);
        GSelGroup.add(L1t);
        GSel.add(L1t);
        
        L2t = new JRadioButton('\u03BB'+"2t-t");
        L2t.addActionListener(this);
        GSelGroup.add(L2t);
        GSel.add(L2t);
        
        L3t = new JRadioButton('\u03BB'+"3t-t");
        L3t.addActionListener(this);
        GSelGroup.add(L3t);
        GSel.add(L3t);
        
        L1tA = new JRadioButton('\u03BB'+"1-t");
        L1tA.addActionListener(this);
        GSelGroup.add(L1tA);
        GSel.add(L1tA);
        
        L2tA = new JRadioButton('\u03BB'+"2-t");
        L2tA.addActionListener(this);
        GSelGroup.add(L2tA);
        GSel.add(L2tA);
        
        L3tA = new JRadioButton('\u03BB'+"3-t");
        L3tA.addActionListener(this);
        GSelGroup.add(L3tA);
        GSel.add(L3tA);
        
        DtA = new JRadioButton("D-t");
        DtA.addActionListener(this);
        GSelGroup.add(DtA);
        GSel.add(DtA);
               
        add("West", GSel);
        
        //slider to control track rate
        slidePanel = new JPanel(new GridLayout(1,2));
        
        slide = new JSlider(1, 1800, rate);
        slide.setInverted(true);
        slide.addChangeListener(slideChange);
        slidePanel.add(slide);
        Cord = new JLabel("Track-rate                              (X, Y, Z, t) = (X, Y, Z, t)");
        slidePanel.add(Cord);
        add("South", slidePanel);
        slide.setEnabled(false);
        Cord.setEnabled(false);
        
        delay = new Timer(slide.getValue()-800, this);
        delay.setRepeats(false);
        
        Lorenz(0,0,125);  //run the lorenz function to after intialized to produce a starting graph
        
      }
      public void Lorenz(int color1, int color2, int color3) {
        np = (int)( ((double)tmax) / dt); //total number of system states to calculate when integrating
        int vl; //number of data points to graph
        if (GraphSel==0 || GraphSel==1 || GraphSel==2){ //if graphing a projection of the attractor, all system states are plotted
            vl = np;
        }
        else { //graphs of Lyapunov information plots points at every normalization after the warm-up period
           vl = (int) (tmax/NormStep) - (int)(NormWait/NormStep);
        }
        double data[] = new double[2*vl]; //the graph library uses a single vector for data arragned (x, y, x, y ...)

        x= new double[np];
        y= new double[np];
        z= new double[np];
        double D;
        double dx = 0.01, dy = 0.01, dz = 0.01; //L1 data
        double dx2 = 0.01, dy2 =0.01, dz2 = 0.01; //L2 data
        double dx3 =0.01, dy3=0.01, dz3=0.01; //L3 data
        x[0] = x0;
        y[0] = y0;
        z[0] = z0;

        
        double L1Sum=0, L1=0, mag=0, L2Sum=0, L2=0, mag2=0, dot12, L3=0, L3Sum=0, mag3=0, dot31, dot32;
        int n=0, u=0;
        double der[] = new double[3]; //left hand side of Lorenz equations as a vector (dx/dt, dy/dt, dz,dt)
        for(i=j=0; i<np; i++,j+=2) { //advance through all the time steps
            
            der = Deriv(x[i], y[i], z[i]); //Deriv function evaluates the Lorenz equations to find a slope used to integrate
            
            if (i < (np-1) ) { //dertermine the state for the next time step
                x[i+1] = x[i] + dt*der[0];
                y[i+1]= y[i] + dt*der[1];
                z[i+1] = z[i] +dt*der[2];
            }
            
            //determine the perturbations from the perturbation equations using PDeriv function that evaluates the linearized Lorenz equations       
            der = PDeriv(x[i], y[i], z[i], dx, dy, dz);               

            dx = dx + dt*der[0];
            dy = dy + dt*der[1];
            dz = dz + dt*der[2];

            der = PDeriv(x[i], y[i], z[i], dx2, dy2, dz2);                    
            
            dx2 = dx2 + dt*der[0];
            dy2 = dy2 + dt*der[1];
            dz2 = dz2 + dt*der[2];
            
            der = PDeriv(x[i], y[i], z[i], dx3, dy3, dz3);      
            
            dx3 = dx3 + dt*der[0];
            dy3 = dy3 + dt*der[1];
            dz3 = dz3 + dt*der[2];
            
            if ( i%(NormStep/dt)==0){ //gram-schmidt reorthogonalizations
                mag= Math.sqrt( dx*dx + dy*dy + dz*dz );
                
                if ( (i*dt)>=NormWait ){ //if it is after the warm-up period, determine an exponent
                    n++;                    
                    L1Sum=L1Sum + Math.log(mag)/NormStep;
                    dx=dx/mag;
                    dy=dy/mag;
                    dz=dz/mag;                  
                    
                    dot12 = dx*dx2+dy*dy2+dz*dz2;
                    dx2 = dx2 - dot12*dx;
                    dy2 = dy2 - dot12*dy;
                    dz2 = dz2 - dot12*dz;
                    
                    mag2 = Math.sqrt( dx2*dx2 + dy2*dy2 + dz2*dz2 );
                    L2Sum=L2Sum + Math.log(mag2)/NormStep;
                    dx2=dx2/mag2;
                    dy2=dy2/mag2;
                    dz2=dz2/mag2;
                    
                    dot32 = dx2*dx3 + dy2*dy3 + dz2*dz3;
                    dot31 = dx*dx3 + dy*dy3 + dz*dz3;
                    dx3 = dx3 - dot32*dx2 - dot31*dx;
                    dy3 = dy3 - dot32*dy2 - dot31*dy;
                    dz3 = dz3 - dot32*dz2 - dot31*dz;
                    
                    mag3 = Math.sqrt( dx3*dx3 + dy3*dy3 + dz3*dz3 );
                    L3Sum=L3Sum + Math.log(mag3)/NormStep;
                    dx3=dx3/mag3;
                    dy3=dy3/mag3;
                    dz3=dz3/mag3;
                    
                    if (GraphSel > 2) { //if a Lyapunov graph is selected
                        data[u]=i*dt; //the 'x'(horizontal) value is the time
                        if (GraphSel == 3) { //'y' (verticle) value is instanteous value of first Lyapunov exponent
                           data[u+1]=Math.log(mag)/NormStep;
                        }
                        else if(GraphSel == 4) { //'y' value is instanteous value of second Lyapunov exponent
                            data[u+1]=Math.log(mag2)/NormStep;
                        }
                        else if(GraphSel == 5) { //'y' value instanteous value of third Lyapunov exponent
                            data[u+1]=Math.log(mag3)/NormStep;
                        }
                        else if(GraphSel == 6) { //'y' value is time avaraged first Lyapunov exponent
                            data[u+1] = L1Sum/n;
                        }
                        else if(GraphSel == 7) { //'y' value is time avaraged second Lyapunov exponent
                            data[u+1] = L2Sum/n;
                        }
                        else if(GraphSel == 8) { //'y' value is time avaraged third Lyapunov exponent
                            data[u+1] = L3Sum/n;
                        }
                        else if(GraphSel == 9) { //'y' value is time avaraged Lyapunov dimension
                            data[u+1] = 2 + ( (L1Sum/n) + (L2Sum/n) )/( Math.abs(L3Sum/n) );     
                        }                  
                        u = u + 2;
                    }                           
                }
                else{ //if in warm-up period reorthonormalize without drawing an exponent
                    dx=dx/mag;
                    dy=dy/mag;
                    dz=dz/mag;               
                    dot12 = dx*dx2+dy*dy2+dz*dz2;
                    dx2 = dx2 - dot12*dx;
                    dy2 = dy2 - dot12*dy;
                    dz2 = dz2 - dot12*dz; 
                    mag2 = Math.sqrt( dx2*dx2 + dy2*dy2 + dz2*dz2 );
                    dx2=dx2/mag2;
                    dy2=dy2/mag2;
                    dz2=dz2/mag2;     
                    dot32 = dx2*dx3 + dy2*dy3 + dz2*dz3;
                    dot31 = dx*dx3 + dy*dy3 + dz*dz3;
                    dx3 = dx3 - dot32*dx2 - dot31*dx;
                    dy3 = dy3 - dot32*dy2 - dot31*dy;
                    dz3 = dz3 - dot32*dz2 - dot31*dz;     
                    mag3 = Math.sqrt( dx3*dx3 + dy3*dy3 + dz3*dz3 );
                    dx3=dx3/mag3;
                    dy3=dy3/mag3;
                    dz3=dz3/mag3;                                                    
                }
            }            
              
            if (GraphSel == 0) { //x-z projection of attractor
                data[j]=x[i];
                data[j+1]=z[i];
            }
            else if (GraphSel==1) { //x-y projection of attractor
                data[j]=x[i];
                data[j+1]=y[i];
            }
            else if (GraphSel==2) { //y-z projection of attractor
                data[j]=y[i];
                data[j+1]=z[i];
            }            
             
        } //end of loop
        
        //determine and display Lyapunov exponent and dimension      
        L1=L1Sum/n;
        L2=L2Sum/n;
        L3=L3Sum/n;
        D= 2 + (L1 + L2)/(Math.abs(L3));
    
        Lambda1.setText("\u03BB1=" + form.format(L1) + "  ");
        Lambda2.setText("\u03BB2=" + form.format(L2) + "  ");
        Lambda3.setText("\u03BB3=" + form.format(L3) + "  ");
        Dim.setText("D=" + form.format(D));        
    
        //replot the new graph
        graph.detachDataSets(); //detach everything from graph
        data1 = graph.loadDataSet(data, (vl) );
        data1.linecolor = new Color(color1 ,color2 , color3);

        // if the axese have not been defined
        if (xaxis == null) {
            xaxis = graph.createAxis(Axis.BOTTOM);
            yaxis_left = graph.createAxis(Axis.LEFT);
            xaxis.setTitleText( "X");        
            xaxis.setTitleFont(new Font("TimesRoman",Font.PLAIN,20));
            xaxis.setLabelFont(new Font("Helvetica",Font.PLAIN,15));
            yaxis_left.setTitleText("Z");
            yaxis_left.setTitleFont(new Font("TimesRoman",Font.PLAIN,20));
            yaxis_left.setLabelFont(new Font("Helvetica",Font.PLAIN,15));

        }
       
        xaxis.detachAll();
        yaxis_left.detachAll();
        xaxis.attachDataSet(data1);
        yaxis_left.attachDataSet(data1);
        graph.repaint(); //erase current and paint new graph
        
    } //end Lorenz function
    
    public double[] Deriv(double x1, double y1, double z1) { //finds derivatives using lorenz equations
         double der[] = new double[3];
         if (RungeEuler) {
            //4th order Runge-Kutta to find derivatives, [0]=>X, [1]=>Y, [2]=>Z
            
            double k1[]= new double[3], k2[]= new double[3], k3[] = new double[3], k4[] = new double[3];
            
            k1[0]=s*(y1 - x1);
            k1[1]=r*x1 - y1 - x1*z1;
            k1[2]=x1*y1 - b*z1;
            
            k2[0]=s*( (y1 + (dt/2)*k1[1]) - (x1 + (dt/2)*k1[0]) );
            k2[1]=r*(x1+ (dt/2)*k1[0]) - (y1 + (dt/2)*k1[1]) - (x1 + (dt/2)*k1[0])*(z1 + (dt/2)*k1[2]);
            k2[2]=(x1 + (dt/2)*k1[0])*(y1 + (dt/2)*k1[1]) - b*(z1 + (dt/2)*k1[2]);
            
            k3[0]=s*( (y1 + (dt/2)*k2[1]) - (x1 + (dt/2)*k2[0]) );
            k3[1]=r*(x1 + (dt/2)*k2[0]) - (y1 + (dt/2)*k2[1]) - (x1 + (dt/2)*k2[0])*(z1 + (dt/2)*k2[2]);
            k3[2]=(x1 + (dt/2)*k2[0])*(y1 + (dt/2)*k2[1]) - b*(z1 + (dt/2)*k2[2]);
                
            k4[0]=s*( (y1 + dt*k3[1]) - (x1 + dt*k3[0]) );
            k4[1]=r*(x1 + dt*k3[0]) - (y1 + dt*k3[1]) - (x1 + dt*k3[0])*(z1 + dt*k3[2]);
            k4[2]=(x1 + dt*k3[0])*(y1 + dt*k3[1]) - b*(z1 + dt*k3[2]);
                
            der[0] = (k1[0] + 2*k2[0] + 2*k3[0] + k4[0])/6;
            der[1] = (k1[1] + 2*k2[1] + 2*k3[1] + k4[1])/6;
            der[2] = (k1[2] + 2*k2[2] + 2*k3[2] + k4[2])/6;
        }
        else {
            //first order Euler
            der[0] = s*(y1 - x1);
            der[1] = r*x1 - y1 - x1*z1;
            der[2] = x1*y1 - b*z1;            
        }
        return der;
    }
    
    public double[] PDeriv(double x1, double y1, double z1, double dx, double dy, double dz) { //finds derivatives of linearized pertibation equations
        double der[] = new double[3];
        if (RungeEuler) {
            //4th order Runge-Kutta to find derivatives, [0]=>X, [1]=>Y, [2]=>Z
            
            double k1[]= new double[3], k2[]= new double[3], k3[] = new double[3], k4[] = new double[3];
            
            k1[0] = s*(dy - dx);
            k1[1] = r*dx - dy - x1*dz - z1*dx;
            k1[2] = x1*dy + y1*dx - b*dz;
            
            k2[0] = s*((dy + (dt/2)*k1[1]) - (dx + (dt/2)*k1[0]));
            k2[1] = r*(dx + (dt/2)*k1[0]) - (dy + (dt/2)*k1[1]) - x1*(dz + (dt/2)*k1[2]) - z1*(dx + (dt/2)*k1[0]);
            k2[2] = x1*(dy + (dt/2)*k1[1]) + y1*(dx + (dt/2)*k1[0]) - b*(dz + (dt/2)*k1[2]);
            
            k3[0] = s*((dy + (dt/2)*k2[1]) - (dx + (dt/2)*k2[0]));
            k3[1] = r*(dx + (dt/2)*k2[0]) - (dy + (dt/2)*k2[1]) - x1*(dz + (dt/2)*k2[2]) - z1*(dx + (dt/2)*k2[0]);
            k3[2] = x1*(dy + (dt/2)*k2[1]) + y1*(dx + (dt/2)*k2[0]) - b*(dz + (dt/2)*k2[2]);
            
            k4[0] = s*((dy + dt*k3[1]) - (dx + dt*k3[0]));
            k4[1] = r*(dx + dt*k3[0]) - (dy + dt*k3[1]) - x1*(dz + dt*k3[2]) - z1*(dx + dt*k3[0]);
            k4[2] = x1*(dy + dt*k3[1]) + y1*(dx + dt*k3[0]) - b*(dz + dt*k3[2]);
            
            der[0] = (k1[0] + 2*k2[0] + 2*k3[0] + k4[0])/6;
            der[1] = (k1[1] + 2*k2[1] + 2*k3[1] + k4[1])/6;
            der[2] = (k1[2] + 2*k2[2] + 2*k3[2] + k4[2])/6;
        }
        else {
            //first order Euler
            der[0] = s*(dy - dx);
            der[1] = r*dx - dy - x1*dz - z1*dx;
            der[2] = x1*dy + y1*dx - b*dz;
        }
        return der;
    }   
                     
    public void Move() { //advances the point when using the track feature
        if (GraphSel < 3) {
            if (!ghost) { //if the ghost has not been plotted, make it using the lorenz function
                    Lorenz(215, 215, 215);
                    ghost = true;
                }
            if (tcount==0) {
                ResetData();
                slide.setEnabled(true);
                Cord.setEnabled(true);
                X=x0;
                Y=y0;
                Z=z0;
            }
            graph.detachDataSet(data2);
            double der[] = new double[3];
            der = Deriv(X, Y, Z);
            X = X + dt*der[0];
            Y = Y + dt*der[1];
            Z = Z + dt*der[2];
            tcount++;
            if (rate < 0) {  //if the rate from slider is negative (see change listener for positive and zero)
                for (int q = 0; q <= Math.abs( (int)(rate/25) ); q++) {  //make |rate/25|+1 steps instead of one
                    der = Deriv(X, Y, Z);
                    X = X + dt*der[0];
                    Y = Y + dt*der[1];
                    Z = Z + dt*der[2];   
                    tcount++;
                }
            }    
            double data[] = new double[2];
            if (GraphSel == 0) {
                data[0] = X;
                data[1] = Z;
            }
            else if (GraphSel == 1) {
                data[0] = X;
                data[1] = Y;
            }
            else if (GraphSel == 2) {
                data[0] = Y;
                data[1] = Z;
            }
            
            data2 = graph.loadDataSet(data, 1);
            data2.linecolor   =  new Color(0,255,0);
            data2.marker      = 8;
            data2.markercolor = new Color(0,0,0);
            xaxis.attachDataSet(data2);
            yaxis_left.attachDataSet(data2);
            graph.repaint();
            Cord.setText( "Track-rate                           (X, Y, Z, t) = (" + form.format(X) + ", " + form.format(Y) + ", " + form.format(Z) + ", " + form.format(tcount*dt) + ")" );
            delay.restart();
        }
    }
    public void ResetData() {       
        BDim.setText("  Db=");
        s = Double.valueOf(TFs.getText());
        b = Double.valueOf(TFb.getText());
        r = Double.valueOf(TFr.getText());
        x0 = Double.valueOf(TFx0.getText());
        y0 = Double.valueOf(TFy0.getText());
        z0 = Double.valueOf(TFz0.getText());
        dt = Double.valueOf(TFdt.getText());
        tmax = Double.valueOf(TFtmax.getText());
        NormStep = Double.valueOf(TFNormStep.getText());
        NormWait = Double.valueOf(TFNormWait.getText());
        ghost=false;
        if (!run) { 
            slide.setEnabled(false);
            Cord.setEnabled(false);
            Cord.setText("Track-rate                           (X, Y, Z, t) = (X, Y, Z, t)");
        }
        if (GraphSel > 2) {
            track.setEnabled(false);
            run = false;
        }
        else {
            track.setEnabled(true);
        }
        
        if (BC) { //if the box-count feature was jsut used, the axes labels need to be reset
            if (GraphSel == 0) {
                xaxis.setTitleText( "X");
                yaxis_left.setTitleText("Z");
            }
            else if (GraphSel == 1) {
                xaxis.setTitleText( "X");
                yaxis_left.setTitleText("Y");
            }
            else if (GraphSel == 2) {
                xaxis.setTitleText("Y");
                yaxis_left.setTitleText("Z");
            }
            else if (GraphSel == 3) {
                xaxis.setTitleText("t");
                yaxis_left.setTitleText("L1t");
            }
            else if (GraphSel == 4) {
                xaxis.setTitleText("t");
                yaxis_left.setTitleText("L2t");
            }
            else if (GraphSel == 5) {
                xaxis.setTitleText("t");
                yaxis_left.setTitleText("L3t");
            }
            else if (GraphSel == 6) {
                xaxis.setTitleText("t");
                yaxis_left.setTitleText("L1");
            }
            else if (GraphSel == 7) {
                xaxis.setTitleText("t");
                yaxis_left.setTitleText("L2");
            }
            else if (GraphSel == 8) {
                xaxis.setTitleText("t");
                yaxis_left.setTitleText("L3");
            }
            else if (GraphSel == 9) {
                xaxis.setTitleText("t");
                yaxis_left.setTitleText("D");
            }
            BC = false;
        }
    }
    
    public void boxCount() {
        i = 0;
        double dsum = 0;
            // iterate through the first 5000 data points (or the entire data set) to determine the average speed of the point (to determine smallest
            //     box size so that ones appearing between data points will be kept to a minimum)
        while ( i < (x.length-1) && i < 5000) {
            dsum = dsum + Math.sqrt( Math.pow( (x[i] - x[i+1]), 2 ) + Math.pow( (y[i] - y[i+1]), 2 ) + Math.pow( (z[i] - z[i + 1]), 2 ) );
            i = i + 1;
        }
        double d = dsum/(i-1); //d is the average distance traveled in one time step

        
            //determine the maximum and minimum points in the data set so that the extent and number of boxes needed can be determined
        i = 0;
        double mn = 99999;
        double mx = -99999;
        while ( i < x.length) {
            if ( x[i] < mn ) { mn = x[i]; }
            else if (x[i] > mx) { mx = x[i]; }
            if ( y[i] < mn ) { mn = y[i]; }
            else if ( y[i] > mx ) { mx = y[i];}
            if ( z[i] < mn ) { mn = z[i]; }
            else if ( z[i] > mx ) { mx = z[i];}
            i = i + 1;
        }
            // increase the max by one so that the max point will not give and out of bounds array index...same thing is not needed for min because
            //      zero based operation and using floor function so min point will just be index zero
        mn = mn;
        mx = mx + 1;

        for (i = 0; i < x.length; i++) { // make the min value into the zero value and adjust the max accordingly
            x[i] = x[i] - mn;
            y[i] = y[i] - mn;
            z[i] = z[i] - mn;
        }
        mx = mx - mn;
        int steps = (int)Math.pow(2, (int)Math.floor( Math.log( (int)Math.ceil( (mx)/(d*2.0) ) ) / Math.log(2.0) )  ); //the number of steps is
            //  found so that a box will be have side length of twice the avg speed to safely incorporate all the data without many boxes in 
            //  between points; the number of steps should be a power of 2 so that they will be easily converted into a courser box 
        double E = mx / steps; // E represents the side length

        boolean[][][][] bx = new boolean[steps][steps][steps][ (int)( Math.log(steps)/Math.log(2.0) ) ]; //4-d array, [x][y][z] location of cube(box)
            //  and [mesh referance number]
        
        i = 0;
        while (i < x.length) { //for each data point, mark the box it inhabits
            bx[ (int)Math.floor( x[i]/E ) ][(int) Math.floor( y[i]/E ) ][ (int)Math.floor( z[i]/E ) ][0] = true;         
            i = i+1;
        }
            // count the number of boxes containing data points
        int N = 0;
        for (i = 0; i < steps; i++) {
            for (j = 0; j < steps; j++) {
                for (k = 0; k < steps; k++) {
                    if (bx[i][j][k][0]) {N++;}
                }
            }
        }
/*      
        datab = new double[steps*2];
        for (int ff = 0; ff<steps*2; ff+=2) {
            for (i = 0; i < steps; i++) {
                for (j = 0; j < steps; j++) {
                    for (k = 0; k < steps; k++) {
                        if (bx[i][j][k][0]) {
                            datab[ff] = i;
                            datab[ff+1] = j;
                            System.out.println(" " + datab[ff] + "     " + datab[ff+1] + "      " + k);
                        }
                        else {
                            datab[ff] = 0;
                            datab[ff+1] = 0;
                        }
                    }
                }
            }
        }
        graph.detachDataSets();
        xaxis.detachAll();
        yaxis_left.detachAll();        
        data3 = graph.loadDataSet(datab, datab.length/2);
        data3.marker      = 8;
        data3.markercolor = new Color(0,0,125);
        xaxis.attachDataSet(data3);
        yaxis_left.attachDataSet(data3);
        graph.repaint();
        

*/       
            
        
        double[] D = new double[(int)(Math.log(steps)/Math.log(2.0))]; //vector containing dimension values for each mesh refernace number
        D[0] = Math.log(N)/Math.log(steps);
        steps = steps/2; //make the mesh courser
        int iter = 1;
        
        while (steps >= 2) { //continue to make mesh courser until there are only 8 cubes (2 boxes in each dimension)
                // for each box in the previous mesh, mark the new box containing that one
            for (i = 0; i < steps*2; i++) {
                for (j = 0; j < steps*2; j++) {
                    for (k = 0; k < steps*2; k++) {
                        if (bx[i][j][k][iter-1]) {
                            bx[ (int)Math.floor(i/2.0) ][ (int)Math.floor(j/2.0) ][ (int)Math.floor(k/2.0) ][iter] = true;
                        }
                    }
                }
            }
            N = 0;
                // count the number of boxes containing data
            for (i = 0; i < steps; i++) {
                for (j = 0; j < steps; j++) {
                    for (k = 0; k < steps; k++) {
                        if (bx[i][j][k][iter]) {N++;}
                    }
                }
            }
            D[iter] = Math.log(N)/Math.log(steps);
            iter++;
            steps = steps/2;
        }
       
        datab = new double[2*D.length];
        
        i = 0;
        j = D.length - 1;
        while (j >= 0) {
            System.out.println("D[" + i/2 + "] = " + D[j]);
            datab[i] = i/2;
            datab[i+1] = D[j];
            j--;
            i+=2;
        }

       
        graph.detachDataSets();
        xaxis.detachAll(); //detach data sets
        yaxis_left.detachAll();
        data3 = graph.loadDataSet(datab, D.length);

        data3.marker      = 8;
        data3.markercolor = new Color(0,125,0);
        xaxis.attachDataSet(data3);
        yaxis_left.attachDataSet(data3);
        xaxis.setTitleText("Mesh");
        yaxis_left.setTitleText("Db"); 
        graph.repaint();
        BDim.setText("  Db=" + form.format(D[0]) );
        BC = true;
    }
    
    public void actionPerformed(ActionEvent ev) { //Action Listener that watches for a cuser command
        if (ev.getSource().equals(bt)) {
            run = false;
            ResetData();
            tcount = 0;           
            Lorenz(0,0,125);
        }
        else if (ev.getSource().equals(track)) {
            Cord.setEnabled(true);
            slide.setEnabled(true);
            run = !run;
            if (run) {            
                Move();
            }
        }
        else if (ev.getSource().equals(zx)) {
            GraphSel = 0;
            ResetData();
            xaxis.setTitleText( "X");
            yaxis_left.setTitleText("Z");
            if (!run) {Lorenz(0,0,125);}
        }
        else if (ev.getSource().equals(yx)) {
            GraphSel = 1;
            ResetData();
            xaxis.setTitleText( "X");
            yaxis_left.setTitleText("Y");
            if (!run) {Lorenz(0,0,125);}
        }
        else if (ev.getSource().equals(zy)){
            GraphSel = 2;
            ResetData();
            xaxis.setTitleText("Y");
            yaxis_left.setTitleText("Z");
            if (!run) {Lorenz(0,0,125);}
        }
        else if (ev.getSource().equals(L1t)) {
            GraphSel = 3;
            ResetData();
            xaxis.setTitleText("t");
            yaxis_left.setTitleText("L1t");
            Lorenz(0,0,125);
        }
        else if (ev.getSource().equals(L2t)) {
            GraphSel = 4;
            ResetData();
            xaxis.setTitleText("t");
            yaxis_left.setTitleText("L2t");
            Lorenz(0,0,125);
        }
        else if (ev.getSource().equals(L3t)) {
            GraphSel = 5;
            ResetData();
            xaxis.setTitleText("t");
            yaxis_left.setTitleText("L3t");
            Lorenz(0,0,125);
        }
        else if (ev.getSource().equals(L1tA)) {
            GraphSel = 6;
            ResetData();
            xaxis.setTitleText("t");
            yaxis_left.setTitleText("L1");
            Lorenz(0,0,125);
        }
        else if (ev.getSource().equals(L2tA)) {
            GraphSel = 7;
            ResetData();
            xaxis.setTitleText("t");
            yaxis_left.setTitleText("L2");
            Lorenz(0,0,125);
        }
        else if (ev.getSource().equals(L3tA)) {
            GraphSel = 8;
            ResetData();
            xaxis.setTitleText("t");
            yaxis_left.setTitleText("L3");
            Lorenz(0,0,125);
        }
        else if (ev.getSource().equals(DtA)) {
            GraphSel = 9;
            ResetData();
            xaxis.setTitleText("t");
            yaxis_left.setTitleText("D");
            Lorenz(0,0,125);
        }
        else if (ev.getSource().equals(RK)) { //JButton RK, which alternates with Eul to specify intergartion method
            run = false; //set run to false to stop the track function
            tcount = 0; //set tcount to zero so that track will start over when switch methods
            RungeEuler = true;
            ResetData();
            Lorenz(0,0,125);
        }
        else if (ev.getSource().equals(Eul)) {
            run = false;
            tcount = 0;
            RungeEuler = false;
            ResetData();
            Lorenz(0,0,125);
        }
        else if (ev.getSource().equals(box)) {
            boxCount();
        }
        else if (ev.getSource().equals(delay)) {
            delay.stop();
            if (run) {
                Move();
            }
        }
    }
}

class MyChangeListener implements ChangeListener { //Change Listener so that the state of the slider can be observed and updated
    example1 parent;
    MyChangeListener(example1 a) {
        parent = a;
    }    
    public void stateChanged(ChangeEvent e) { //when the slider state is changed
        parent.rate = parent.slide.getValue() - 800; //set rate to the slider value minus 800 (negative rates indicate multiple steps)
        if (parent.rate > 0){ parent.delay.setInitialDelay(parent.rate); } //if rate is positive, set it as the delay
        else { parent.delay.setInitialDelay(1); } //if rate is nonpositive, use 1ms as delay
        //rest of negative rate logic in move-function
    }
}
