import java.awt.*;
import java.applet.*;
import java.net.URL;
import graph.*;

import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.text.*;
import java.lang.*;


public class vonkoch extends Applet implements ActionListener {

      Graph2D graph;
      DataSet data1;
      Axis    xaxis;
      Axis    yaxis_left;
      Axis    yaxis_right;
      URL markerURL;
      double length, tlength, area, tarea;
      JPanel stuff, select;
      JButton advance, restart;
      int i, j;
      double d[], x[];
      JLabel leng, iteration, ar;
      int iter = 0;
      JRadioButton lengthb, areab, lineb;
      

      public void init() {
        x = new double[4];
        length = 1;
        tlength = 1;
        area = 0;
        tarea = 0;
/*
**      Get the passed parameters
*/

        String mfile    = getParameter("MARKERS");
/*
**      Create the Graph instance and modify the default behaviour
*/
        graph = new Graph2D();
        graph.drawzero = false;
        graph.drawgrid = false;
        graph.borderTop = 50;
/*
**      Load a file containing Marker definitions
*/
        try {
           markerURL = new URL(getDocumentBase(),mfile);
           graph.setMarkers(new Markers(markerURL));
        } catch(Exception e) {
           System.out.println("Failed to create Marker URL!");
        }


        setLayout( new BorderLayout() );
        add("Center", graph);
/*
**      Calculate the first data Set.
*/
            x[0] = 0;
            x[1] = 0;
            x[2] = Math.sqrt(12);
            x[3] = 0;

        data1 = graph.loadDataSet(x,2);
        data1.linestyle = 1;
        data1.linecolor   =  new Color(0,125,0);


        xaxis = graph.createAxis(Axis.BOTTOM);     
        xaxis.attachDataSet(data1);
        xaxis.setTitleText(" ");
        
        yaxis_left = graph.createAxis(Axis.LEFT);
        yaxis_left.attachDataSet(data1); 
        yaxis_left.minimum = -.25;
        yaxis_left.maximum = 1.25;
        yaxis_left.setTitleText(" ");
        
        select = new JPanel(new GridLayout(6,1));
        select.add(new JLabel("Plot Select"));
        
        ButtonGroup sel = new ButtonGroup();
        lineb = new JRadioButton("von Koch curve");
        lineb.addActionListener(this);
        lineb.setSelected(true);
        sel.add(lineb);
        select.add(lineb);
        
        lengthb = new JRadioButton("Length");
        lengthb.addActionListener(this);
        sel.add(lengthb);        
        select.add(lengthb);
        
        areab = new JRadioButton("Area");
        areab.addActionListener(this);
        sel.add(areab);
        select.add(areab);
        
        add("West", select);
        
        stuff=new JPanel(new GridLayout(6, 1));
        
        iteration = new JLabel("Iteration 0");
        stuff.add(iteration); 
        
        advance = new JButton("Next");
        advance.addActionListener(this);
        stuff.add(advance);
        
        restart=new JButton("           Restart           ");
        restart.addActionListener(this);
        stuff.add(restart);
        
        leng = new JLabel("Length = 1");
        stuff.add(leng);
        
        ar = new JLabel("Area = 0");
        stuff.add(ar);
        
        add("East", stuff);
    }
    
    public void Adv() {
        iter++;       
        d = new double[6*(x.length/2 - 1) + x.length];
        j = 0;
        
        area = length*length/6/Math.sqrt(12); // 1/2base(length/3) * height(length/sqrt(12))    
        length = length/3;
            
        
        for (i = 0; i < (x.length - 2); i+=2, j+=8) {
            
            
            d[j] = x[i];
            d[j+1] = x[i+1];
            
            d[j+2] = (x[i+2] - x[i])/3 + x[i];
            d[j+3] = (x[i+3] - x[i+1])/3 + x[i+1];
            
            //perpendicular/length to normalize times length/sqrt(12) so length simplifies
            d[j+4] = -(x[i+3] - x[i+1]) / Math.sqrt(12) + (x[i+2] - x[i])/2 + x[i]; 
            d[j+5] = (x[i+2] - x[i])/Math.sqrt(12) + (x[i+3] - x[i+1])/2 + x[i+1];
                        
            d[j+6] = (x[i+2] - x[i])*2/3 + x[i]; 
            d[j+7] = (x[i+3] - x[i+1])*2/3 + x[i+1];   
            
            d[j+8] = x[i+2];    
            d[j+9] = x[i+3];
            
            tlength = tlength + length;
            tarea = tarea + area;
            
        }
        
        x = new double[ d.length ];
        for (i = 0; i < d.length; i++) {
            x[i] = d[i];
        }
        
        leng.setText("Length = "+tlength);
        iteration.setText("Iteration "+iter);
        ar.setText("Area = "+tarea);
        
        graph.detachDataSets();
        data1 = graph.loadDataSet(x, x.length/2);
        data1.linestyle = 1;
        data1.linecolor   =  new Color(0,125,0);
        yaxis_left.attachDataSet(data1);
        yaxis_left.setTitleText(" ");
        yaxis_left.minimum = -.25;
        yaxis_left.maximum = 1.25;
        
        xaxis.attachDataSet(data1);
        xaxis.setTitleText(" ");
        
        graph.repaint();    
    }    
    public void plotLength() {
        d = new double[40];
        d[0] = 0;
        d[1] = 1;
        j = 1;
        for (i = 2; i < 40; i+=2) {
            d[i] = j;
            d[i+1] = Math.pow(4.0/3.0, j);
            j++;
        } 
        graph.detachDataSets();
        data1 = graph.loadDataSet(d, 20);
        data1.linestyle = 1;
        data1.linecolor   =  new Color(125,0,0);
        yaxis_left.attachDataSet(data1);
        yaxis_left.setTitleText("Length");
        xaxis.attachDataSet(data1);
        xaxis.setTitleText("Iteration");
        graph.repaint();
    }
    public void plotArea() {
        d = new double[20];
        d[0] = 0;
        d[1] = 0;
        j = 1;
        for (i = 2; i < 20; i+=2){
            d[i] = j;
            d[i+1] = d[i-1] + 1.0/6.0/Math.sqrt(12)*Math.pow(4.0/9.0, j-1);
            j++;
        }
        graph.detachDataSets();
        data1 = graph.loadDataSet(d, 10);
        data1.linestyle = 1;
        data1.linecolor   =  new Color(125,0,0);
        yaxis_left.attachDataSet(data1);
        yaxis_left.setTitleText("Area");
        xaxis.attachDataSet(data1);
        xaxis.setTitleText("Iteration");
        graph.repaint();
    }
    public void restartf() {
        x = new double[4];
        length = 1;      
        tlength = 1;
        area = 0;
        tarea = 0;
        x[0] = 0;
        x[1] = 0;
        x[2] = Math.sqrt(12);
        x[3] = 0;
        graph.detachDataSets();
        data1 = graph.loadDataSet(x, x.length/2);
        data1.linestyle = 1;
        data1.linecolor   =  new Color(0,125,0);
        yaxis_left.attachDataSet(data1);
        yaxis_left.minimum = -.25;
        yaxis_left.maximum = 1.25;
        yaxis_left.setTitleText(" ");
        xaxis.attachDataSet(data1);
        xaxis.setTitleText(" ");
        graph.repaint();
        iter = 0;
        leng.setText("Length = 1");
        ar.setText("Area = 0");
        iteration.setText("Iteration 0");
    }
    public void actionPerformed(ActionEvent ev) {
        if (ev.getSource().equals(advance)) {
            lineb.setSelected(true);
            Adv();
        }
        else if (ev.getSource().equals(restart)) {
            lineb.setSelected(true);
            restartf();
        }
        else if (ev.getSource().equals(lineb)) {
            restartf();
        }
        else if (ev.getSource().equals(lengthb)) {
            plotLength();
        }
        else if (ev.getSource().equals(areab)) {
            plotArea();
        }
            
    }             
}
